<?php
/***************************************************************************
 *   Copyright (C) 2005-2006 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
if(!defined("IN_FUSION")) {
    header("Location: ../../index.php");
    exit;
}
if(file_exists(INFUSIONS."auto_db_backup_panel/locale/".$settings['locale'].".php")) 
{
    include INFUSIONS."auto_db_backup_panel/locale/".$settings['locale'].".php";
} else {
    include INFUSIONS."aw_auto_backup_panel/locale/German.php";
}


// CONST
define("WAIT_TIME", 60*60*24);	// in secs.


// VARS
$dir = ADMIN . "/db_backups/";
$db_file_filter = $dir . "*.sql*";
$touch_file = $dir . "aw_last_update";


// FUNCS
function need_backup() {
    global $touch_file;
    if(file_exists($touch_file)) {
	$mtime = filemtime($touch_file);
	return((time()-$mtime) > WAIT_TIME);
    }
    return true;
}

/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright (c) 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------+
| Database Backup developed by CrappoMan
| email: simonpatterson@dsl.pipex.com
+----------------------------------------------------*/
//from administration/db_backup.php
function gzcompressfile($source,$level=false){
        $dest=$source.'.gz';
        $mode='wb'.$level;
        $error=false;
        if($fp_out=gzopen($dest,$mode)){
                if($fp_in=fopen($source,'rb')){
                        while(!feof($fp_in))
                        gzputs($fp_out,fread($fp_in,1024*512));
                        fclose($fp_in);
                }else $error=true;
                gzclose($fp_out);
        }else $error=true;
        if($error)return false; else return $dest;
}
function do_backup() {
    global $dir, $db_name, $db_prefix, $crlf;

    $backup_type = ".gz";

    $dbbackupdir = $dir;

    $query = "SHOW TABLES FROM $db_name";
    $query_id = dbquery($query);
    if($query_id) {
	while($row = dbarray($query_id)) {
	    foreach($row as $key => $val) {
		$db_tables[$val] = $val;
	    }
	}
    } else {
	return false;
    }

    if(count($db_tables)>0) {
	$crlf="\n";
	ob_start();
	@ob_implicit_flush(0);
	echo "#----------------------------------------------------------".$crlf;
	echo "# PHP-Fusion SQL Data Dump".$crlf;
	echo "# Database Name: `$db_name`".$crlf;
	echo "# Table Prefix: `".$db_prefix."`".$crlf;
	echo "# Date: `".date("d/m/Y H:i")."`".$crlf;
	echo "#----------------------------------------------------------".$crlf;
	dbquery('SET SQL_QUOTE_SHOW_CREATE=1');
	foreach($db_tables as $table){
	    @set_time_limit(1200);
	    dbquery("OPTIMIZE TABLE $table");
	    echo $crlf."#".$crlf."# Structure for Table `".$table."`".$crlf."#".$crlf;
	    echo "DROP TABLE IF EXISTS `$table`;$crlf";
	    $row=dbarraynum(dbquery("SHOW CREATE TABLE $table"));
	    echo $row[1].";".$crlf;
	    $result=dbquery("SELECT * FROM $table");
	    if($result&&dbrows($result)) {
		echo $crlf."#".$crlf."# Table Data for `".$table."`".$crlf."#".$crlf;
		$column_list="";
		$num_fields=mysql_num_fields($result);
		for($i=0;$i<$num_fields;$i++){
		    $column_list.=(($column_list!="")?", ":"")."`".mysql_field_name($result,$i)."`";
		}
	    }
	    while($row=dbarraynum($result)){
		$dump="INSERT INTO `$table` ($column_list) VALUES (";
		for($i=0;$i<$num_fields;$i++){
		    $dump.=($i>0)?", ":"";
		    if(!isset($row[$i])){
			$dump.="NULL";
		    }elseif($row[$i]=="0"||$row[$i]!=""){
			$type=mysql_field_type($result,$i);
			if($type=="tinyint"||$type=="smallint"||$type=="mediumint"||$type=="int"||$type=="bigint"||$type=="timestamp"){
			    $dump.=$row[$i];
			}else{
			    $search_array=array('\\','\'',"\x00","\x0a","\x0d","\x1a");
			    $replace_array=array('\\\\','\\\'','\0','\n','\r','\Z');
			    $row[$i]=str_replace($search_array,$replace_array,$row[$i]);
			    $dump.="'$row[$i]'";
			}
		    }else{
		    $dump.="''";
		    }
		}
		$dump.=');';
		echo $dump.$crlf;
	    }
	}
	$contents=ob_get_contents();
	ob_end_clean();
	@umask(0111);
	mt_srand((double)microtime()*1000000);
	$backup_rand = rand(1000000, 9999999);
	$backup_hash = substr(md5($backup_rand), 8, 8); 
	$file="backup_".$backup_hash."_".date('Y-m-d_Hi').".sql";
	$fp=fopen("$dbbackupdir$file","w");
	$ok=fwrite($fp,$contents);
	fclose($fp);
	if($backup_type==".gz") {
	    if(gzcompressfile("$dbbackupdir$file",9)!=false) {
		unlink("$dbbackupdir$file");
	    }
	}
    }
    return true;
//    redirect(FUSION_SELF);
}


// ACTION
$err_txt = "";
if(need_backup()) {
    if(do_backup()) {
	if(!@touch($touch_file)) {
	    $err_txt = $locale['aw_err_touch'];
	}
    } else {
	$err_txt = $locale['aw_err_db'];
    }
}


// GUI
if(iSUPERADMIN) {
	opentable($locale['aw_title']);

	echo "<div align='center'>";
	if(empty($err_txt)) {
		echo $locale['aw_last'] . "<br/>"
			. showdate("shortdate", filemtime($touch_file));
	} else {
		echo $err_txt;
	}
	echo "</div>";

	closetable();
}


?>
